/**************---< TECHNO ROAD.inc >---**************/
/*                                                   */
/*   File        :coron_wait.c                       */
/*   Version     :v2.1.0                             */
/*   Date        :2010/05/18                         */
/*   Author      :Norio Sakagami                     */
/*   Description :Wait routine Library Source        */
/*                                                   */
/*    Copyright(C) TECHNOROAD.inc                    */
/*                 http://techno-road.com/           */
/*****************************************************/
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_lib.h"
#include "coron_lib.h"

/* Global variables ----------------------------------------------------------*/
u8 	wait_timer_flag=0;
u32 wait_timer_count=0;

/* Prototype -----------------------------------------------------------------*/
void wait_loop(vu32 loop){while(loop--);}

//==============================================================================
// Wait֐
//==============================================================================
void wait_init(void){
    //SysTick(waitp)
	SysTick_Configuration();
}

//==============================================================================
// Wait֐(SysTick荞)
//==============================================================================
void Handler_SysTick(void){
	if(wait_timer_count==0){
		wait_timer_flag=0;		//ݑ҂tONA		
	}
	else{
		wait_timer_count--;		//c芄݉񐔂|1
	}
}

//==============================================================================
// SysTick 
//==============================================================================
void SysTick_Configuration(void){
  SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);	//SysTick̃NbN\[XHCLK/8(9MHz)ɃZbg
  SysTick_SetReload(900);								//[hJE^lݒ(100[us])
  SysTick_CounterCmd(SysTick_Counter_Disable);			//SysTickJE^֎~
  SysTick_ITConfig(ENABLE);								//SysTick荞݂
}

//==============================================================================
// SysTick Handlergwait֐( x100us)
//==============================================================================
void wait_timer(u32 time_x100us){
	SysTick_CounterCmd(SysTick_Counter_Disable);		//SysTickJE^֎~
	SysTick_SetReload(900);								//[hJE^lݒ(100[us])
	SysTick_CounterCmd(SysTick_Counter_Clear);			//SysTickJE^NA
	wait_timer_count= time_x100us-1;					//JE^lݒ
	wait_timer_flag	= 1;								//ݑ҂tOZbg		
	SysTick_CounterCmd(SysTick_Counter_Enable);			//SysTickJE^Jn
	while(wait_timer_flag);								//SysTick荞݂̂҂
}

//==============================================================================
// SysTick Handlergwait֐ P[sec]
//==============================================================================
void wait_timer_sec(u32 time_sec){
	SysTick_CounterCmd(SysTick_Counter_Disable);		//SysTickJE^֎~
	SysTick_SetReload(9000000);							//[hJE^lݒ(1[msec])
	SysTick_CounterCmd(SysTick_Counter_Clear);			//SysTickJE^NA
	wait_timer_count= time_sec-1;						//JE^lݒ
	wait_timer_flag	= 1;								//ݑ҂tOZbg		
	SysTick_CounterCmd(SysTick_Counter_Enable);			//SysTickJE^Jn
	while(wait_timer_flag);								//SysTick荞݂̂҂
}

//==============================================================================
// SysTick Handlergwait֐ P[msec]
//==============================================================================
void wait_timer_msec(u32 time_msec){
	SysTick_CounterCmd(SysTick_Counter_Disable);		//SysTickJE^֎~
	SysTick_SetReload(9000);							//[hJE^lݒ(1[msec])
	SysTick_CounterCmd(SysTick_Counter_Clear);			//SysTickJE^NA
	wait_timer_count= time_msec-1;						//JE^lݒ
	wait_timer_flag	= 1;								//ݑ҂tOZbg		
	SysTick_CounterCmd(SysTick_Counter_Enable);			//SysTickJE^Jn
	while(wait_timer_flag);								//SysTick荞݂̂҂
}

//==============================================================================
// SysTick Handlergwait֐ P[usec]
//==============================================================================
void wait_timer_usec(u32 time_usec){
	SysTick_CounterCmd(SysTick_Counter_Disable);		//SysTickJE^֎~
	SysTick_SetReload(9);								//[hJE^lݒ(1[usec])
	SysTick_CounterCmd(SysTick_Counter_Clear);			//SysTickJE^NA
	wait_timer_count= time_usec-1;						//JE^lݒ
	wait_timer_flag	= 1;								//ݑ҂tOZbg		
	SysTick_CounterCmd(SysTick_Counter_Enable);			//SysTickJE^Jn
	while(wait_timer_flag);								//SysTick荞݂̂҂
}