
#include "stm32f10x_lib.h"	//ST}CNCu
#include "coron_lib.h"		//CoronpCu

#include "xbee_uart.h"


unsigned char uart_buffer_current_position = 0;
unsigned char uart_buffer[128];
unsigned char uart_buffer_read_position = 0;


int uart_block = 0;

void uart_setup()
{
	int i;
	for(i = 0;i < 10;i++) {
		UART_getc(0);
	}
	
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
    NVIC_InitTypeDef NVIC_InitStructure;
    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQChannel;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    USART_ITConfig(CN_UART, USART_IT_RXNE, ENABLE);	
}


void uart_setBlockingPolicy(int policy) {
	uart_block = policy;
}



int uart_isReceived() {
	return uart_buffer_current_position != uart_buffer_read_position;
}

void uart_putc(unsigned char c) {
	UART_putc(c);
}

int uart_getc(unsigned char* c) {
	if(uart_block) {
		while(!uart_isReceived());
	}
	*c = uart_buffer[uart_buffer_read_position];
	uart_buffer_read_position++;
	if(uart_buffer_read_position == 128) {
		uart_buffer_read_position = 0;
	}
	return 0;
}

